<?php
/**
 * Class which returns the class map definition
 * @package
 */
class ClassMap
{
    /**
     * Returns the mapping between the WSDL Structs and generated Structs' classes
     * This array is sent to the \SoapClient when calling the WS
     * @return string[]
     */
    final public static function get()
    {
        return array(
            'Fault_type' => '\\StructType\\Fault_type',
            'Header_type' => '\\StructType\\Header_type',
            'ItemInformation_type' => '\\StructType\\ItemInformation_type',
            'OrderInformation_type' => '\\StructType\\OrderInformation_type',
            'PromotionInformation_type' => '\\StructType\\PromotionInformation_type',
            'AuthenticationFault' => '\\StructType\\AuthenticationFault',
            'OrderInformationRequest' => '\\StructType\\OrderInformationRequest',
            'Authentication' => '\\StructType\\Authentication',
            'OrderInformationResponse' => '\\StructType\\OrderInformationResponse',
            'AllInvoiceRequest' => '\\StructType\\AllInvoiceRequest',
            'GetInvoices' => '\\StructType\\GetInvoices',
            'InvoiceInformation' => '\\StructType\\InvoiceInformation',
            'Invoice' => '\\StructType\\Invoice',
            'Header' => '\\StructType\\Header',
            'Header_Type' => '\\StructType\\Header_Type_1',
            'Parties' => '\\StructType\\Parties',
            'Party' => '\\StructType\\Party',
            'PaymentTerms' => '\\StructType\\PaymentTerms',
            'PaymentTerm' => '\\StructType\\PaymentTerm',
            'AllowanceCharges' => '\\StructType\\AllowanceCharges',
            'AllowanceCharge' => '\\StructType\\AllowanceCharge',
            'LineItems' => '\\StructType\\LineItems',
            'LineItem' => '\\StructType\\LineItem',
            'OrderedItem' => '\\StructType\\OrderedItem',
            'ShippedItem' => '\\StructType\\ShippedItem',
            'GTINS' => '\\StructType\\GTINS',
            'GTIN' => '\\StructType\\GTIN',
            'InvoiceRequestAllNew' => '\\StructType\\InvoiceRequestAllNew',
            'Action' => '\\StructType\\Action',
            'RequestAll' => '\\StructType\\RequestAll',
            'InvoiceRequestByDate' => '\\StructType\\InvoiceRequestByDate',
            'RequestByDate' => '\\StructType\\RequestByDate',
            'InvoiceResponse' => '\\StructType\\InvoiceResponse',
            'InvoiceResponseType' => '\\StructType\\InvoiceResponseType',
            'Information' => '\\StructType\\Information',
            'InvoiceDownload' => '\\StructType\\InvoiceDownload',
            'ListInvoice' => '\\StructType\\ListInvoice',
            'RequestAllNew' => '\\StructType\\RequestAllNew',
            'CatalogueRequest' => '\\StructType\\CatalogueRequest',
            'Response' => '\\StructType\\Response',
            'ResponseType' => '\\StructType\\ResponseType',
        );
    }
}
