<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for AllowanceCharge StructType
 * @subpackage Structs
 */
class AllowanceCharge extends AbstractStructBase
{
    /**
     * The Code
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $Code;
    /**
     * The Amount
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var float
     */
    public $Amount;
    /**
     * The GoodsAndServicesTaxCode
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $GoodsAndServicesTaxCode;
    /**
     * The ProvincialTaxCode
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var mixed
     */
    public $ProvincialTaxCode;
    /**
     * The PartOfUnitPrice
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $PartOfUnitPrice;
    /**
     * Constructor method for AllowanceCharge
     * @uses AllowanceCharge::setCode()
     * @uses AllowanceCharge::setAmount()
     * @uses AllowanceCharge::setGoodsAndServicesTaxCode()
     * @uses AllowanceCharge::setProvincialTaxCode()
     * @uses AllowanceCharge::setPartOfUnitPrice()
     * @param string $code
     * @param float $amount
     * @param string $goodsAndServicesTaxCode
     * @param mixed $provincialTaxCode
     * @param string $partOfUnitPrice
     */
    public function __construct($code = null, $amount = null, $goodsAndServicesTaxCode = null, $provincialTaxCode = null, $partOfUnitPrice = null)
    {
        $this
            ->setCode($code)
            ->setAmount($amount)
            ->setGoodsAndServicesTaxCode($goodsAndServicesTaxCode)
            ->setProvincialTaxCode($provincialTaxCode)
            ->setPartOfUnitPrice($partOfUnitPrice);
    }
    /**
     * Get Code value
     * @return string|null
     */
    public function getCode()
    {
        return $this->Code;
    }
    /**
     * Set Code value
     * @param string $code
     * @return \StructType\AllowanceCharge
     */
    public function setCode($code = null)
    {
        // validation for constraint: string
        if (!is_null($code) && !is_string($code)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($code)), __LINE__);
        }
        $this->Code = $code;
        return $this;
    }
    /**
     * Get Amount value
     * @return float|null
     */
    public function getAmount()
    {
        return $this->Amount;
    }
    /**
     * Set Amount value
     * @param float $amount
     * @return \StructType\AllowanceCharge
     */
    public function setAmount($amount = null)
    {
        $this->Amount = $amount;
        return $this;
    }
    /**
     * Get GoodsAndServicesTaxCode value
     * @return string|null
     */
    public function getGoodsAndServicesTaxCode()
    {
        return $this->GoodsAndServicesTaxCode;
    }
    /**
     * Set GoodsAndServicesTaxCode value
     * @param string $goodsAndServicesTaxCode
     * @return \StructType\AllowanceCharge
     */
    public function setGoodsAndServicesTaxCode($goodsAndServicesTaxCode = null)
    {
        // validation for constraint: string
        if (!is_null($goodsAndServicesTaxCode) && !is_string($goodsAndServicesTaxCode)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($goodsAndServicesTaxCode)), __LINE__);
        }
        $this->GoodsAndServicesTaxCode = $goodsAndServicesTaxCode;
        return $this;
    }
    /**
     * Get ProvincialTaxCode value
     * @return mixed|null
     */
    public function getProvincialTaxCode()
    {
        return $this->ProvincialTaxCode;
    }
    /**
     * Set ProvincialTaxCode value
     * @param mixed $provincialTaxCode
     * @return \StructType\AllowanceCharge
     */
    public function setProvincialTaxCode($provincialTaxCode = null)
    {
        $this->ProvincialTaxCode = $provincialTaxCode;
        return $this;
    }
    /**
     * Get PartOfUnitPrice value
     * @return string|null
     */
    public function getPartOfUnitPrice()
    {
        return $this->PartOfUnitPrice;
    }
    /**
     * Set PartOfUnitPrice value
     * @param string $partOfUnitPrice
     * @return \StructType\AllowanceCharge
     */
    public function setPartOfUnitPrice($partOfUnitPrice = null)
    {
        // validation for constraint: string
        if (!is_null($partOfUnitPrice) && !is_string($partOfUnitPrice)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($partOfUnitPrice)), __LINE__);
        }
        $this->PartOfUnitPrice = $partOfUnitPrice;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\AllowanceCharge
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
